package com.cxytiandi.session.core;

import java.io.IOException;
import java.util.UUID;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.context.ApplicationContext;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.web.context.support.WebApplicationContextUtils;

public class BaseFilter implements Filter {

	private StringRedisTemplate stringRedisTemplate;
	
	@Override
	public void init(FilterConfig filterConfig) throws ServletException {
		ApplicationContext ac = WebApplicationContextUtils.getWebApplicationContext(filterConfig.getServletContext());
		stringRedisTemplate = ac.getBean(StringRedisTemplate.class);
	}

	@Override
	public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain)
			throws IOException, ServletException {
		HttpServletRequest req = (HttpServletRequest) request;
		HttpServletResponse resp = (HttpServletResponse) response;
		Cookie[] cookies = req.getCookies();
		if (cookies == null) {
			resp.addCookie(new Cookie("SESSION", UUID.randomUUID().toString().replace("-", "")));
		}
		chain.doFilter(new SessionReposotiryRequestWrapper(req, stringRedisTemplate), resp);
	}

	@Override
	public void destroy() {
		// TODO Auto-generated method stub
		
	}

}
