package com.cxytiandi.session.core;

import java.util.Set;
import java.util.concurrent.TimeUnit;

import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletRequestWrapper;
import javax.servlet.http.HttpSession;

import org.springframework.data.redis.core.StringRedisTemplate;

public class SessionReposotiryRequestWrapper extends HttpServletRequestWrapper {
	private StringRedisTemplate stringRedisTemplate;
	private String id;
	
	public SessionReposotiryRequestWrapper(HttpServletRequest request) {
		super(request);
	}

	public SessionReposotiryRequestWrapper(HttpServletRequest request, StringRedisTemplate stringRedisTemplate) {
		super(request);
		this.stringRedisTemplate = stringRedisTemplate;
		Cookie[] cookies = request.getCookies();
		if (cookies != null) {
			for (Cookie cookie : cookies) {
				if (cookie.getName().equals("SESSION")) {
					id = cookie.getValue();
					//更新session失效时间
					if (stringRedisTemplate.hasKey(id)) {
						Set<String> members = stringRedisTemplate.opsForSet().members(id);
						for (String mem : members) {
							updateValueTime(mem);
						}
					}
					break;
				}
			}
		}
	}
	
	private void updateValueTime(String mem) {
		String key = id + "_" + mem;
		String keyType = id + "_type_" + mem;
		String value = stringRedisTemplate.opsForValue().get(key);
		String valueType = stringRedisTemplate.opsForValue().get(keyType);
		stringRedisTemplate.opsForValue().set(key, value, 30, TimeUnit.MINUTES);
		stringRedisTemplate.opsForValue().set(keyType, valueType, 30, TimeUnit.MINUTES);
	}

	@Override
	public HttpSession getSession() {
		System.err.println("---------------------");
		return new CustomHttpSession(stringRedisTemplate, id);
	}
	
	
}
